const fs = Plugin.fs;
const versionFile = './version.desktop.json';
const asar = Npm.require('asar');
const Future = Npm.require('fibers/future');
import node6Preset from 'babel-preset-node6';

fs.existsSync = (function existsSync(path) {
    try {
        return !!this.statSync(path);
    } catch (e) {
        return null;
    }
}).bind(fs);

if (!fs.existsSync(versionFile)) {
    fs.writeFileSync(versionFile, JSON.stringify({
        version: null,
        compatibilityVersion: null
    }, null, 2), 'UTF-8');
}

class MeteorDesktopBundler {
    constructor(fileSystem) {
        this.fs = fileSystem;
    }

    /**
     * Compiles the protocols.index.js file.
     *
     * @param {Array} files - Array with files to process.
     */
    processFilesForTarget(files) {
        console.log(files[0].getArch());

        const inputFile = files[0];
        const future = new Future();
        const r = future.resolver();
        asar.createPackage(
            './.desktop',
            './desktop.asar',
            () => {
                console.log('in');
                r();
            }

        );
        console.log('before');
        future.wait();
        console.log('after');
        inputFile.addAsset({
            path: inputFile.getPathInPackage(),
            data: JSON.stringify({
                version: null,
                compatibilityVersion: null
            }, null, 2),
        });


    }

}

if (typeof Plugin !== 'undefined') {
    Plugin.registerCompiler(
        { extensions: ['desktop.json'] },
        () => new MeteorDesktopBundler(Plugin.fs)
    );
}
